#URB    39  control  0x40 0x0c 0x85 0x00 len     1 wrote 0x12
#... 5 more lines ...
BEGIN {
        line[0]="control  0x40 0x0c 0x85 0x.* len     1 wrote 0x..";
        line[1]="control  0x40 0x0c 0x85 0x.* len     1 wrote 0x00";
        line[2]="control  0x40 0x0c 0x85 0x.* len     1 wrote 0x00";
        line[3]="control  0x40 0x0c 0x85 0x.* len     1 wrote 0x..";
        line[4]="control  0x40 0x0c 0x85 0x.* len     1 wrote 0x..";
        line[5]="control  0x40 0x0c 0x85 0x.* len     1 wrote 0x00";
        line[6]="no match at all";
	line[7]="control  0xc0 0x0c 0x84 0x.* len     1 read  0x..";
	line[8]="control  0x40 0x0c 0x85 0x.* len     1 wrote 0x..";
}
{
	do {
		position = 0;
		start = $2;
		indx = $7;
		while( match($0, line[position]) && ($7 == indx) )
		{
			pile[position] = $0;
			byteval[position] = $11
#			printf "%d %s", position, "found";
			position++;
			getline;
		}
		if(position == 6)
		{
#define RESERVE_UNIT            0x16
#define RELEASE_UNIT            0x17
#define	CUSTOM_READ_d7		0xd7
#define	CUSTOM_READ_dd		0xdd
#define	CUSTOM_WRITE_dc		0xdc
			switch (byteval[0]) {
			case "0x00" :
				cmdval = "TEST_UNIT_READY";
				break;
			case "0x03" :
				cmdval = "REQUEST_SENSE";
				break;
			case "0x08" :
				cmdval = "READ";
				break;
			case "0xd7" :
				cmdval = "CUSTOM_READ_d7";
				break;
			case "0xdd" :
				cmdval = "CUSTOM_READ_dd";
				break;
			case "0x0a" :
				cmdval = "WRITE";
				break;
			case "0xdc" :
				cmdval = "CUSTOM_WRITE_dc";
				break;
			case "0x0f" :
				cmdval = "PARAM";
				break;
			case "0x12" :
				cmdval = "INQUIRY";
				break;
			case "0x15" :
				cmdval = "WRITE_MODE";
				break;
			case "0x18" :
				cmdval = "COPY";
				break;
			case "0x1b" :
				cmdval = "SCAN";
				break;
			default:
				cmdval = byteval[0];
			}
			printf "URBS  %d - %d  -----pie2_WriteSCSIcommand( %s", start, start + 5, cmdval;
			for( i = 1; i < position; i++)
				printf " %s", byteval[i];
			printf " ), index %s\n", indx;

			if( match($0, line[7]) )
			{
				print $0;
				getline;
				if( match(cmdval, "WRIT") )
				{
					position = 0;
					start = $2;
					indx = $7;
					while( match($0, line[8]) && ($7 == indx) )
					{
						byteval[position] = $11
						position++;
						getline;
					}
					printf "URBS  %d - %d  -----pie2_WriteSCSIdata(", start, start + position - 1;
                                        if (cmdval == "WRITE")
					{
						switch (byteval[0]) {
							case "0x01" :
								cmdval2 = "SET_POWER_SAVE_CONTROL";
								break;
							case "0x10" :
								cmdval2 = "DWNLD_GAMMA_TABLE";
								break;
							case "0x11" :
								cmdval2 = "DWNLD_HALFTONE";
								break;
							case "0x12" :
								cmdval2 = "SET_SCAN_FRAME";
								break;
							case "0x13" :
								cmdval2 = "SET_EXP_TIME";
								break;
							case "0x14" :
								cmdval2 = "SET_HIGHLIGHT_SHADOW";
								break;
							case "0x16" :
								cmdval2 = "SEND_CAL_DATA";
								break;
							case "0x81" :
								cmdval2 = "READ_POWER_SAVE_CONTROL";
								break;
							case "0x90" :
								cmdval2 = "READ_GAMMA_TABLE";
								break;
							case "0x91" :
								cmdval2 = "READ_HALFTONE";
								break;
							case "0x92" :
								cmdval2 = "READ_SCAN_FRAME";
								break;
							case "0x93" :
								cmdval2 = "READ_EXP_TIME";
								break;
							case "0x94" :
								cmdval2 = "READ_HIGHLIGHT_SHADOW";
								break;
							case "0x95" :
								cmdval2 = "READ_CAL_INFO";
								break;
							default:
								cmdval2 = byteval[0];
								break;
							}
						byteval[0] = cmdval2;
					}
					for( i = 0; i < position; i++)
						printf " %s", byteval[i];
					printf " ), index %s\n", indx;
				}
			}
		} else
			for(i = 0; i < position; i++)
				print pile[i]
	} while (position != 0)
	print $0;
}

